using System;
using System.Xml;

using System.Web.Services.Protocols;

namespace WSCompression
{
    [Serializable]
    internal sealed class CompressionFault : SoapHeaderException
    {
        public const string ReferencedDataNotFoundMessage = "Referenced element not found in document";
        public static readonly XmlQualifiedName ReferencedDataNotFoundCode = new XmlQualifiedName( "ReferencedDataNotFound", WSCompression.NamespaceURI );

        public const string InvalidCompressionMessage = "An error was discovered processing the <Compression> header";
        public static readonly XmlQualifiedName InvalidCompressionCode = new XmlQualifiedName( "InvalidCompression", WSCompression.NamespaceURI );

        public const string UnsupportedAlgorithmMessage = "An unsupported compression algorithm was used";
        public static readonly XmlQualifiedName UnsupportedAlgorithmCode = new XmlQualifiedName( "UnsupportedAlgorithm", WSCompression.NamespaceURI );

        public CompressionFault( string message, XmlQualifiedName code ) : base( message, code ) { }
    }
}