using System;
using System.Xml;
using System.Web.Services.Protocols;

using Microsoft.Web.Services3;

namespace WSCompression
{
    public sealed class CompressionInputFilter : SoapFilter
    {
        public override SoapFilterResult ProcessMessage( SoapEnvelope envelope )
        {
            if ( envelope == null )
                throw new ArgumentNullException( "envelope" );

            if ( envelope.Header == null )
                return SoapFilterResult.Continue;

            XmlElement compressionElement = null;

            for ( int i = 0; i < envelope.Header.ChildNodes.Count; ++i )
            {
                XmlElement element = envelope.Header.ChildNodes[ i ] as XmlElement;
                if ( element != null
                    && Compression.IsValidElement( element ) )
                {
                    if ( compressionElement != null ) //Multiple headers ... 
                        throw new CompressionFault( CompressionFault.InvalidCompressionMessage, CompressionFault.InvalidCompressionCode );

                    compressionElement = element;
                }
            }

            if ( compressionElement == null )
                return SoapFilterResult.Continue;

            Compression.Decompress( compressionElement );

            return SoapFilterResult.Continue;
        }
    }
}